 MEMBER
 MAP
   INCLUDE('xDynStr.inc'),ONCE
 END

!****************************************************************************************************************************
DynStr                       PROCEDURE(*STRING DestStr,  STRING SourStr, BYTE FlagExact = FALSE, LONG InitSize = 20)
!
!        STRING   .
!      &STRING    *STRING,      .
!
! :
! MyDynStr            &STRING
! ...
! MyDynStr &= DynStr(MyDynStr, '  ')
! MyDynStr &= DynStr(MyDynStr, '   ')
!
! :
! DestStr      -    (  ),      
!                DestStr &= DynStr(DestStr, ' ')
!
! SourStr      -     DestStr
!
! FlagExact    -        SourStr  DestStr. TRUE -  ( , 
!                ), FALSE -     DestStr     SourStr,   
!                 ( ).
!
! InitSize     -      (  FlagExact = FALSE)


 CODE

 RETURN DynStrRef(DestStr, SourStr, FlagExact, InitSize)
!****************************************************************************************************************************
DynStrRef                    PROCEDURE(*STRING DestStr, *STRING SourStr, BYTE FlagExact = FALSE, LONG InitSize = 20)
!
!        STRING   .    
!   .   . DynStr

DestOver                     GROUP
DestRef                        &STRING
                             END
DestParam                    GROUP,PRE(DEST),OVER(DestOver)
BufRef                         LONG
BufSize                        LONG
                             END

SourOver                     GROUP
SourRef                        &STRING
                             END
SourParam                    GROUP,PRE(SOUR),OVER(SourOver)
BufRef                         LONG
BufSize                        LONG
                             END

 CODE

 DestOver.DestRef &= DestStr
 SourOver.SourRef &= SourStr

 IF SOUR:BufSize
    IF DEST:BufSize
       IF SOUR:BufSize > DEST:BufSize OR (FlagExact AND SOUR:BufSize < DEST:BufSize)
          DISPOSE(DestOver.DestRef)
          DestOver.DestRef &= NEW STRING(SOUR:BufSize)
       END
    ELSE
       IF FlagExact OR SOUR:BufSize > InitSize
          DestOver.DestRef &= NEW STRING(SOUR:BufSize)
       ELSE
          IF InitSize > 0 ; DestOver.DestRef &= NEW STRING(InitSize)
          ELSE            ; DestOver.DestRef &= NEW STRING(1).
       END
    END

    IF DEST:BufSize
       DestOver.DestRef = SourOver.SourRef
    !ELSE !  
    END
 ELSE
    IF ~DEST:BufSize
       IF FlagExact OR InitSize < 1 ; DestOver.DestRef &= NEW STRING(1)
       ELSE                         ; DestOver.DestRef &= NEW STRING(InitSize).
    END

    IF DEST:BufSize
       DestOver.DestRef = ''
    !ELSE !  
    END
 END

 RETURN DestOver.DestRef
!****************************************************************************************************************************
